#ifndef MAINOBJECT_H
#define MAINOBJECT_H

#include <QObject>
#include <stdio.h>
#include <QDir>
#include <QDebug>
#include <QString>
#include <QTcpSocket>
#include <QFileInfo>
#include <QJsonDocument>
#include <QStandardPaths>
#include <memory>


#ifndef Q_OS_ANDROID
#include <QtSerialPort/QtSerialPort>
#include <QtSerialPort/QSerialPortInfo>
#include <QCommandLineParser>
#endif

#include "microcontroller.h"
#include "ui/mainwindow.h"
#include "items/itemstore.h"
#include "items/auxitem.h"

class MainObject : public QObject
{
	Q_OBJECT
public:

	//io
	QIODevice * const masterIODevice = nullptr;

	Microcontroller micro;

	const QString settingsPath;

	//items
	ItemStore items;

public:
	explicit MainObject(QIODevice* ioDevice);
	~MainObject();
};

#endif // MAINOBJECT_H
