#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "itemscrollbox.h"
#include "itemsettingsdialog.h"
#include "itemcreationdialog.h"

MainWindow::MainWindow(Microcontroller * const micro, ItemStore* items, QWidget *parent) :
	QMainWindow(parent),
	stopShort(QKeySequence(Qt::Key_Space), this),
	ui(new Ui::MainWindow),
	_micro(micro)
{
	ui->setupUi(this);

	connect(&stopShort, &QShortcut::activated, _micro, &Microcontroller::estop);
	connect(ui->pushButton_stop, &QPushButton::clicked, _micro, &Microcontroller::estop);
	connect(ui->pushButton_refesh, &QPushButton::clicked, _micro, &Microcontroller::requestState);

	connect(items, &ItemStore::itemAdded, ui->relayList, &ItemScrollBox::addItem);
	connect(items, &ItemStore::itemDeleted, ui->relayList, &ItemScrollBox::removeItem);

	for(size_t i = 0; i < items->getItems()->size(); ++i)
	{
		ui->relayList->addItem(items->getItems()->at(i));
	}

	connect(ui->relayList, &ItemScrollBox::deleteRequest, items, &ItemStore::removeItem);

	ui->pushButton_addItem->hide();
}

MainWindow::~MainWindow()
{
	delete ui;
}

/*
void MainWindow::showItemCreationDialog()
{
    ItemCreationDialog diag(this);
    diag.show();
    if(diag.exec())
    {
        createdItem(diag.item);
    }
}
*/
