#pragma once

#include <QWidget>
#include <memory>
#include <QShortcut>
#include "itemsettingsdialog.h"
#include "../items/item.h"
#include "itemwidget.h"

namespace Ui
{
class TrainWidget;
}

class TrainWidget : public ItemWidget
{
	Q_OBJECT
protected:
	std::vector< std::unique_ptr<QShortcut> > shortcuts_;

	void disable();

private slots:
	void setValue(int8_t value);
	void moveToValue(int8_t value);
	void deleteItem();

	void stepUp();
	void stepDown();

	void f1(int state);
	void f2(int state);
	void f3(int state);
	void f4(int state);
	void reverse();

public:
	explicit TrainWidget(std::weak_ptr<Item> item, QWidget *parent);
	~TrainWidget();
	void setShortcuts(QKeySequence up, QKeySequence down, QKeySequence rev);

public slots:

	virtual void stateChanged(int state);

private:
	Ui::TrainWidget *ui;
};

